﻿# Declare characters used by this game.
define e = Character('Eileen', color="#c8ffc8")

# The game starts here.
label start:
    
    #Here we declare a Sentence object, I name it 'line', it could be named whatever you want though        
    $ line = Sentence()
    
    e "This is a class to help do user input and also have 'synonyms' or equivalent statements."
    
    e "It is very likely this code has bugs as it has not been fully tested yet."
    
    e "Let's start simple, type in a sentence of some sort with a greeting.  If you're at a loss, then
     try having 'hello' in your sentence."
    
    #addsynonyms(str, str) - adds synonyms to reference during certain function calls 
    #the first argument is a word that we are going to define synonyms for
    #the second argument is a string of word/phrases that are separated by commas
    $ line.addsynonyms("hello",
        "hi, yo, hey, what's up, what's happening, good day, good morning, good evening, sup")
    
label hello:

    #clear() will clear all sentence data except for synonym data
    $ line.clear()

    #empty() returns whether or not there is sentence data
    while line.empty():        
        
        #sentence(str) will set the sentence data based on the string
        $ line.sentence(renpy.input("Type a sentence with a greeting:"))
        
    #contains(str) will return a number from zero to the number of words/phrases you are checking
    #in this example, we are checking one word so it will return zero if the sentence doesn't contain
    #'hello' or one of its synonyms, and one if it does contain 'hello' or one of its synonyms
    if not line.contains("hello"):
        e "You might be typing in a greeting that the code doesn't recognize, but there are a few common
         ones other than 'hello' that you can try.  So, try again please."
        
        jump hello

    e "Hello there! The game would have accepted a few variations:\n
       hello, hi, yo, hey, what's up, what's happening, good day, good morning, good evening, sup"

    e "Now, to use an example from the forums, I will now see where you'd like to go."
    
    e "Where should we go? park, beach, or mountain\nThere are other keywords
       that will trigger each of those options as well."

    #continue to add synonym data to 'line'
    #if we ever need to clear the synonym data for 'line', we could call line.clearsynonyms()
    $ line.addsynonyms("park", "trees, tree, grass, hill, hills, green, parks")
    $ line.addsynonyms("beach", "sand, ocean, sea, hot, swim, swimming, beaches")
    $ line.addsynonyms("mountain", "white, cold, snow, ice, skiing, ski, mountains")

label where:
    
    $ line.clear()

    while line.empty():        
        $ line.sentence(renpy.input("Where do you want to go? (park, beach, mountain)"))

    #contains(str) is checking three words here, so it can return a value from zero to three
    #this 'if' statment is seeing if there are no matches to the words or one of their synonyms
    if line.contains("park, beach, mountain") == 0:
        e "You managed to type in nothing that would trigger.  Try again."
        
        jump where
       
    #contains(str) is checking three words here, so it can return a value from zero to three
    #this 'if' statement is checking to see that one and only one trigger word or a synonym matches
    if line.contains("park, beach, mountain") == 1:
        if line.contains("park"):
            jump park
        elif line.contains("beach"):
            jump beach
        elif line.contains("mountain"):
            jump mountain

    #if the code reaches here, it's because the input matched two or three triggers words
    e "Well, now this is funny.  You typed in trigger words for more than one option."
    
    e "Your sentence could have made complete sense too, but I have the code set up to
       look for you to type about one location only.  Try again, please."
    
    jump where

label park:
    
    #at this point the code, we know the user matched some word to trigger the 'park' response
    
    e "The park sounds nice!"    
    
    #containsword(str) checks if a word is in the sentence
    #it's important to note that it does not reference synonyms at all during its check
    if line.containsword("trees") or line.containsword("tree"):
        e "I like hanging out underneath the shade of the trees."
    elif line.containsword("grass"):
        e "I want to go out on the grass and have a picnic."
    elif line.containsword("hill") or line.containsword("hills"):
        e "If we go up to the top of the hill at the park, we can see the whole city from there."
    else:
        e "I think that we'll have a good time at the park."
    
    e "Trigger words other than 'park' were:\n
       trees, tree, grass, hill, hills, green, parks"
    
    e "The code is setup to give a slightly different response for some of the triggers word."
    
    e "As the code stands right now though, it would say the same thing even if the person said:\n
       'I hate the park.'"
    
    jump out

label beach:
    
    #at this point the code, we know the user matched some word to trigger the 'beach' response
    
    e "Did you bring your bathing suit?  If we're going to the beach, you'll need yours."
    
    #containsword(str) checks if the word is in the sentence
    #it's important to note that it does not reference synonyms at all during its check
    if line.containsword("sand"):
        e "We could totally build a sand castle!"
    elif line.containsword("hot"):
        e "I just might lay out in the sun for a bit to get a tan."    
    else:
        e "It'd be nice to go for a swim."
        
    e "I always keep my bathing suit with me... what? that's weird?"
    
    e "Anyway, the code is setup to give a slightly different response for some of the trigger words."
    
    e "Trigger words other than 'beach' were:\n
       sand, ocean, sea, hot, swim, swimming, beaches"
    
    e "The user is currently able to trick the code and it would have had the same response for a sentence
       like: 'Ugh, the beach is the last place that I would want to go.'"
            
    jump out
    
label mountain:
        
    #at this point the code, we know the user matched some word to trigger the 'mountain' response
    
    e "The mountains could be interesting."
    
    #containsword(str) checks if the word is in the sentence
    #it's important to note that it does not reference synonyms at all during its check
    if line.containsword("snow") or line.containsword("white"):
        e "Would we make snow angels?"
    elif line.containsword("cold"):
        e "I'm not the biggest fan of cold weather though.  I'd have to bundle up."
    elif line.containsword("skiing") or line.containsword("ski"):
        e "I've never been skiing before.  I think it'd be kind of scary!"
    
    e "Trigger words other than 'mountain' were:\n
       white, cold, snow, ice, skiing, ski, mountains"
    
    e "The code has a few responses based on which trigger word was detected."
    
    e "Unfortunately, the code can be abused as it would also accept a sentence like:\n
       'How can we go to the mountains?  There are none around here.'"
    
label out:
    
    e "There might be some features to add to the code to help check and mitigate these kinds of
       scenarios."
    
    e "An open-ended text entry response system will rarely achieve its intended effect.  It is also
       a little bit up to the user and how much they enjoy the process."
    
    e "I may add more features to this code after discussion on the forums.  Links are in comments at
       the top of the sentence.rpy file."
    
    return
    
    
    
    